commit c6c398c6c51e48893f658eb6e6c08b47f41b085d
Author: jim-p <jimp@netgate.com>
Date:   Wed Nov 21 16:30:48 2018 -0200

    Fix #9121: Initialize arrays to prevent PHP 7 errors

diff --git a/src/etc/inc/easyrule.inc b/src/etc/inc/easyrule.inc
index e654f1ac9a..18c8318556 100644
--- a/src/etc/inc/easyrule.inc
+++ b/src/etc/inc/easyrule.inc
@@ -98,13 +98,8 @@ function easyrule_block_rule_create($int = 'wan', $ipproto = "inet") {
 		return true;
 	}
 
-	/* No rules, start a new array */
-	if (!is_array($config['filter']['rule'])) {
-		$config['filter']['rule'] = array();
-	}
-
-	filter_rules_sort();
 	init_config_arr(array('filter', 'rule'));
+	filter_rules_sort();
 	$a_filter = &$config['filter']['rule'];
 
 	/* Make up a new rule */
@@ -160,11 +155,6 @@ function easyrule_block_alias_add($host, $int = 'wan') {
 		return false;
 	}
 
-	/* If there are no aliases, start an array */
-	if (!is_array($config['aliases']['alias'])) {
-		$config['aliases']['alias'] = array();
-	}
-
 	init_config_arr(array('aliases', 'alias'));
 	$a_aliases = &$config['aliases']['alias'];
 
@@ -286,13 +276,8 @@ function easyrule_block_host_add($host, $int = 'wan', $ipproto = "inet") {
 function easyrule_pass_rule_add($int, $proto, $srchost, $dsthost, $dstport, $ipproto) {
 	global $config;
 
-	/* No rules, start a new array */
-	if (!is_array($config['filter']['rule'])) {
-		$config['filter']['rule'] = array();
-	}
-
-	filter_rules_sort();
 	init_config_arr(array('filter', 'rule'));
+	filter_rules_sort();
 	$a_filter = &$config['filter']['rule'];
 
 	/* Make up a new rule */
diff --git a/src/etc/inc/gwlb.inc b/src/etc/inc/gwlb.inc
index 7c0a436b00..f0ec9daae7 100644
--- a/src/etc/inc/gwlb.inc
+++ b/src/etc/inc/gwlb.inc
@@ -1972,12 +1972,7 @@ function validate_gateway($gateway_settings, $id = "", $parent_ip = "", $parent_
 function save_gateway($gateway_settings, $realid = "") {
 	global $config;
 
-	if (!is_array($config['gateways'])) {
-		$config['gateways'] = array();
-	}
-	if (!is_array($config['gateways']['gateway_item'])) {
-		$config['gateways']['gateway_item'] = array();
-	}
+	init_config_arr(array('gateways', 'gateway_item'));
 	$a_gateway_item = &$config['gateways']['gateway_item'];
 	$reloadif = "";
 	$gateway = array();
diff --git a/src/etc/inc/interfaces.inc b/src/etc/inc/interfaces.inc
index 4ccd245ec7..0766682dff 100644
--- a/src/etc/inc/interfaces.inc
+++ b/src/etc/inc/interfaces.inc
@@ -1808,7 +1808,7 @@ function interfaces_carp_set_maintenancemode($carp_maintenancemode) {
 		$config["virtualip_carp_maintenancemode"] = true;
 		write_config(gettext("Enter CARP maintenance mode"));
 	}
-
+	init_config_arr(array('virtualip', 'vip'));
 	$viparr = &$config['virtualip']['vip'];
 
 	if (is_array($viparr)) {
@@ -5278,6 +5278,7 @@ function convert_real_interface_to_friendly_interface_name($interface = "wan", $
 	global $config;
 
 	/* XXX: For speed reasons reference directly the interface array */
+	init_config_arr(array('interfaces'));
 	$ifdescrs = &$config['interfaces'];
 	//$ifdescrs = get_configured_interface_list(true);
 
diff --git a/src/etc/inc/interfaces_fast.inc b/src/etc/inc/interfaces_fast.inc
index 67c1ae837e..d94132b344 100644
--- a/src/etc/inc/interfaces_fast.inc
+++ b/src/etc/inc/interfaces_fast.inc
@@ -61,6 +61,7 @@ function convert_real_interface_to_friendly_interface_name_fast() {
 
 	$out = array();
 	/* XXX: For speed reasons reference directly the interface array */
+	init_config_arr(array('interfaces'));
 	$ifdescrs = &$config['interfaces'];
 	$iffriendlynames = array_keys($ifdescrs);
 	$out = array_flip(get_real_interface_fast($iffriendlynames));
diff --git a/src/etc/inc/itemid.inc b/src/etc/inc/itemid.inc
index a0d51cd1da..ddce19b616 100644
--- a/src/etc/inc/itemid.inc
+++ b/src/etc/inc/itemid.inc
@@ -48,6 +48,7 @@ function delete_id($id, &$array) {
 	unset($array[$delete_index]);
 
 	// Update the separators
+	init_config_arr(array('filter', 'separator', strtolower($if)));
 	$a_separators = &$config['filter']['separator'][strtolower($if)];
 	// get rule index within interface
 	$ridx = ifridx($if, $delete_index);
diff --git a/src/etc/inc/pfsense-utils.inc b/src/etc/inc/pfsense-utils.inc
index eef65663dc..2d7d23b8b6 100644
--- a/src/etc/inc/pfsense-utils.inc
+++ b/src/etc/inc/pfsense-utils.inc
@@ -807,6 +807,7 @@ function remove_text_from_file($file, $text) {
 function after_sync_bump_adv_skew() {
 	global $config, $g;
 	$processed_skew = 1;
+	init_config_arr(array('virtualip', 'vip'));
 	$a_vip = &$config['virtualip']['vip'];
 	foreach ($a_vip as $vipent) {
 		if ($vipent['advskew'] <> "") {
@@ -2704,7 +2705,7 @@ function xml2array($contents, $get_attributes = 1, $priority = 'tag') {
 					$current[$tag . '_attr'] = $attributes_data;
 				}
 				$repeated_tag_index[$tag . '_' . $level] = 1;
-				$current = & $current[$tag];
+				$current = &$current[$tag];
 			} else {
 				if (isset ($current[$tag][0])) {
 					$current[$tag][$repeated_tag_index[$tag . '_' . $level]] = $result;
@@ -2721,7 +2722,7 @@ function xml2array($contents, $get_attributes = 1, $priority = 'tag') {
 					}
 				}
 				$last_item_index = $repeated_tag_index[$tag . '_' . $level] - 1;
-				$current = & $current[$tag][$last_item_index];
+				$current = &$current[$tag][$last_item_index];
 			}
 		} elseif ($type == "complete") {
 			if (!isset ($current[$tag])) {
@@ -2756,7 +2757,7 @@ function xml2array($contents, $get_attributes = 1, $priority = 'tag') {
 				}
 			}
 		} elseif ($type == 'close') {
-			$current = & $parent[$level -1];
+			$current = &$parent[$level -1];
 		}
 	}
 	return ($xml_array);
diff --git a/src/etc/inc/pkg-utils.inc b/src/etc/inc/pkg-utils.inc
index 9202720378..d147f23cd9 100644
--- a/src/etc/inc/pkg-utils.inc
+++ b/src/etc/inc/pkg-utils.inc
@@ -668,7 +668,7 @@ function sync_package($package_name) {
 		return;	 // No package belongs to the pkg_id passed to this function.
 	}
 
-	$package =& $config['installedpackages']['package'][$pkg_id];
+	$package = &$config['installedpackages']['package'][$pkg_id];
 	if (!file_exists("/usr/local/pkg/" . $package['configurationfile'])) {
 		log_error(sprintf(gettext("The %s package is missing its configuration file and must be reinstalled."), $package['name']));
 		delete_package_xml($package['name']);
@@ -950,14 +950,13 @@ function delete_package_xml($package_name, $when = "post-deinstall") {
 	pkg_debug(sprintf(gettext("Removing %s package... "), $package_name));
 	update_status(sprintf(gettext("Removing %s components..."), $package_name) . "\n");
 	/* parse package configuration */
-	init_config_arr(array('installedpackages', 'package'));
+	init_config_arr(array('installedpackages', 'package', $pkgid));
 	$packages = &$config['installedpackages']['package'];
+	$pkg_info = &$packages[$pkgid];
 	init_config_arr(array('installedpackages', 'menu'));
 	$menus = &$config['installedpackages']['menu'];
 	init_config_arr(array('installedpackages', 'service'));
 	$services = &$config['installedpackages']['service'];
-	init_config_arr(array('installedpackages', 'package', $pkgid));
-	$pkg_info = &$packages[$pkgid];
 	if (file_exists("/usr/local/pkg/" . $pkg_info['configurationfile'])) {
 		$pkg_config = parse_xml_config_pkg("/usr/local/pkg/" . $packages[$pkgid]['configurationfile'], "packagegui");
 		/* remove menu items */
diff --git a/src/etc/inc/priv.inc b/src/etc/inc/priv.inc
index 730b672f01..017dd15d15 100644
--- a/src/etc/inc/priv.inc
+++ b/src/etc/inc/priv.inc
@@ -214,18 +214,12 @@ function getPrivPages(& $entry, & $allowed_pages) {
 	}
 
 	foreach ($entry['priv'] as $pname) {
-		if (strncmp($pname, "page-", 5)) {
-			continue;
-		}
-		$priv = &$priv_list[$pname];
-		if (!is_array($priv)) {
-			continue;
-		}
-		$matches = &$priv['match'];
-		if (!is_array($matches)) {
+		if (strncmp($pname, "page-", 5) ||
+		    !is_array($priv_list[$pname]) ||
+		    !is_array($priv_list[$pname]['match'])) {
 			continue;
 		}
-		foreach ($matches as $match) {
+		foreach ($priv_list[$pname]['match'] as $match) {
 			$allowed_pages[] = $match;
 		}
 	}
diff --git a/src/etc/inc/services.inc b/src/etc/inc/services.inc
index d45e77638d..d9f4601c90 100644
--- a/src/etc/inc/services.inc
+++ b/src/etc/inc/services.inc
@@ -1726,7 +1726,8 @@ function services_dhcrelay_configure() {
 	/* kill any running dhcrelay */
 	killbypid("{$g['varrun_path']}/dhcrelay.pid");
 
-	$dhcrelaycfg =& $config['dhcrelay'];
+	init_config_arr(array('dhcrelay'));
+	$dhcrelaycfg = &$config['dhcrelay'];
 
 	/* DHCPRelay enabled on any interfaces? */
 	if (!isset($dhcrelaycfg['enable'])) {
@@ -1801,7 +1802,8 @@ function services_dhcrelay6_configure() {
 	/* kill any running dhcrelay */
 	killbypid("{$g['varrun_path']}/dhcrelay6.pid");
 
-	$dhcrelaycfg =& $config['dhcrelay6'];
+	init_config_arr(array('dhcrelay6'));
+	$dhcrelaycfg = &$config['dhcrelay6'];
 
 	/* DHCPv6 Relay enabled on any interfaces? */
 	if (!isset($dhcrelaycfg['enable'])) {
@@ -2731,7 +2733,7 @@ function configure_cron() {
 	$crontab_contents = file("/etc/crontab", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
 
 	for ($i = 0; $i < count($crontab_contents); $i++) {
-		$cron_item =& $crontab_contents[$i];
+		$cron_item = &$crontab_contents[$i];
 		if (strpos($cron_item, "# pfSense specific crontab entries") !== false) {
 			array_splice($crontab_contents, $i - 1);
 			break;
diff --git a/src/etc/inc/shaper.inc b/src/etc/inc/shaper.inc
index 6d0e760137..a23f4376e9 100644
--- a/src/etc/inc/shaper.inc
+++ b/src/etc/inc/shaper.inc
@@ -308,7 +308,8 @@ function get_queue_stats() {
 function &get_reference_to_me_in_config(&$mypath) {
 	global $config;
 
-	$ptr =& $config['shaper'];
+	init_config_arr(array('shaper'));
+	$ptr = &$config['shaper'];
 	foreach ($mypath as $indeks) {
 		if (!is_array($ptr)) {
 			$ptr = array();
@@ -319,7 +320,7 @@ function &get_reference_to_me_in_config(&$mypath) {
 		if (!is_array($ptr['queue'][$indeks])) {
 			$ptr['queue'][$indeks] = array();
 		}
-		$ptr =& $ptr['queue'][$indeks];
+		$ptr = &$ptr['queue'][$indeks];
 	}
 
 	return $ptr;
@@ -328,9 +329,10 @@ function &get_reference_to_me_in_config(&$mypath) {
 function unset_object_by_reference(&$mypath) {
 	global $config;
 
-	$ptr =& $config['shaper'];
+	init_config_arr(array('shaper'));
+	$ptr = &$config['shaper'];
 	for ($i = 0; $i < count($mypath) - 1; $i++) {
-		$ptr =& $ptr['queue'][$mypath[$i]];
+		$ptr = &$ptr['queue'][$mypath[$i]];
 	}
 	unset($ptr['queue'][$mypath[$i]]);
 }
@@ -338,9 +340,10 @@ function unset_object_by_reference(&$mypath) {
 function &get_dn_reference_to_me_in_config(&$mypath) {
 	global $config;
 
-	$ptr =& $config['dnshaper'];
+	init_config_arr(array('dnshaper'));
+	$ptr = &$config['dnshaper'];
 	foreach ($mypath as $indeks) {
-		$ptr =& $ptr['queue'][$indeks];
+		$ptr = &$ptr['queue'][$indeks];
 	}
 
 	return $ptr;
@@ -349,9 +352,10 @@ function &get_dn_reference_to_me_in_config(&$mypath) {
 function unset_dn_object_by_reference(&$mypath) {
 	global $config;
 
-	$ptr =& $config['dnshaper'];
+	init_config_arr(array('dnshaper'));
+	$ptr = &$config['dnshaper'];
 	for ($i = 0; $i < count($mypath) - 1; $i++) {
-		$ptr =& $ptr['queue'][$mypath[$i]];
+		$ptr = &$ptr['queue'][$mypath[$i]];
 	}
 	unset($ptr['queue'][$mypath[$i]]);
 }
@@ -522,8 +526,8 @@ function get_interface_bandwidth($object) {
 	global $altq_list_queues;
 
 	$int = $object->GetInterface();
-	$altq =& $altq_list_queues[$int];
-	if ($altq) {
+	if (isset($altq_list_queues[$int])) {
+		$altq = &$altq_list_queues[$int];
 		$bw_3 = $altq->GetBandwidth();
 		$bw_3 = $bw_3 * get_bandwidthtype_scale($altq->GetBwscale());
 		return floatval($bw_3);
@@ -5014,12 +5018,7 @@ function read_altq_config() {
 	global $altq_list_queues, $config;
 	$path = array();
 
-	if (!is_array($config['shaper'])) {
-		$config['shaper'] = array();
-	}
-	if (!is_array($config['shaper']['queue'])) {
-		$config['shaper']['queue'] = array();
-	}
+	init_config_arr(array('shaper', 'queue'));
 	$a_int = &$config['shaper']['queue'];
 
 	$altq_list_queues = array();
@@ -5055,18 +5054,12 @@ function read_dummynet_config() {
 	global $dummynet_pipe_list, $config;
 	$path = array();
 
-	if (!is_array($config['dnshaper'])) {
-		$config['dnshaper'] = array();
-	}
-	if (!is_array($config['dnshaper']['queue'])) {
-		$config['dnshaper']['queue'] = array();
-	}
+	init_config_arr(array('dnshaper', 'queue'));
 	$a_int = &$config['dnshaper']['queue'];
 
 	$dummynet_pipe_list = array();
 
-	if (!is_array($config['dnshaper']['queue']) ||
-	    !count($config['dnshaper']['queue'])) {
+	if (!count($config['dnshaper']['queue'])) {
 		return;
 	}
 
diff --git a/src/etc/inc/system.inc b/src/etc/inc/system.inc
index 65462ef808..5751e83858 100644
--- a/src/etc/inc/system.inc
+++ b/src/etc/inc/system.inc
@@ -1190,14 +1190,10 @@ EOD;
 function system_webgui_create_certificate() {
 	global $config, $g;
 
-	if (!is_array($config['ca'])) {
-		$config['ca'] = array();
-	}
-	$a_ca =& $config['ca'];
-	if (!is_array($config['cert'])) {
-		$config['cert'] = array();
-	}
-	$a_cert =& $config['cert'];
+	init_config_arr(array('ca'));
+	$a_ca = &$config['ca'];
+	init_config_arr(array('cert'));
+	$a_cert = &$config['cert'];
 	log_error(gettext("Creating SSL Certificate for this host"));
 
 	$cert = array();
diff --git a/src/etc/inc/upgrade_config.inc b/src/etc/inc/upgrade_config.inc
index 0f22794922..3c0140d365 100644
--- a/src/etc/inc/upgrade_config.inc
+++ b/src/etc/inc/upgrade_config.inc
@@ -89,6 +89,7 @@ function upgrade_010_to_011() {
 	}
 
 	/* convert filter rules */
+	init_config_arr(array('filter', 'rule'));
 	$n = count($config['filter']['rule']);
 	for ($i = 0; $i < $n; $i++) {
 
@@ -133,6 +134,7 @@ function upgrade_010_to_011() {
 	}
 
 	/* convert shaper rules */
+	init_config_arr(array('pfqueueing', 'rule'));
 	$n = count($config['pfqueueing']['rule']);
 	if (is_array($config['pfqueueing']['rule'])) {
 		for ($i = 0; $i < $n; $i++) {
@@ -215,6 +217,7 @@ function upgrade_013_to_014() {
 	global $config;
 	/* convert shaper rules (make pipes) */
 	if (is_array($config['pfqueueing']['rule'])) {
+		init_config_arr(array('pfqueueing', 'pipe'));
 		$config['pfqueueing']['pipe'] = array();
 
 		for ($i = 0; isset($config['pfqueueing']['rule'][$i]); $i++) {
@@ -514,8 +517,9 @@ function upgrade_027_to_028() {
 
 function upgrade_028_to_029() {
 	global $config;
-	$rule_item = array();
+	init_config_arr(array('filter', 'rule'));
 	$a_filter = &$config['filter']['rule'];
+	$rule_item = array();
 	$rule_item['interface'] = "enc0";
 	$rule_item['type'] = "pass";
 	$rule_item['source']['any'] = true;
@@ -901,6 +905,7 @@ function upgrade_045_to_046() {
 	/* Upgrade load balancer from slb to relayd */
 	if (is_array($config['load_balancer']['virtual_server']) && count($config['load_balancer']['virtual_server'])) {
 		$vs_a = &$config['load_balancer']['virtual_server'];
+		init_config_arr(array('load_balancer', 'lbpool'));
 		$pool_a = &$config['load_balancer']['lbpool'];
 		$pools = array();
 		/* Index pools by name */
@@ -1970,11 +1975,8 @@ function upgrade_053_to_054() {
 		$gateway_group_arr = array();
 		$gateways = return_gateways_array();
 		$group_name_changes = array();
-		if (!is_array($config['gateways']['gateway_item'])) {
-			$config['gateways']['gateway_item'] = array();
-		}
-
-		$a_gateways =& $config['gateways']['gateway_item'];
+		init_config_arr(array('gateways', 'gateway_item'));
+		$a_gateways = &$config['gateways']['gateway_item'];
 		foreach ($lbpool_arr as $lbpool) {
 			if ($lbpool['type'] == "gateway") {
 				// Gateway Groups have to have valid names in pf, old lb pools did not. Clean them up.
@@ -2406,9 +2408,11 @@ function upgrade_062_to_063() {
 function upgrade_063_to_064() {
 	global $config;
 	$j = 0;
+	init_config_arr(array('ppps', 'ppp'));
+	init_config_arr(array('interfaces'));
 	$ifcfg = &$config['interfaces'];
 
-	if (is_array($config['ppps']['ppp']) && count($config['ppps']['ppp'])) {
+	if (count($config['ppps']['ppp'])) {
 		foreach ($config['ppps']['ppp'] as $pppid => $ppp) {
 			$config['ppps']['ppp'][$pppid]['if'] = "ppp".$j;
 			$config['ppps']['ppp'][$pppid]['ptpid'] = $j;
@@ -2426,9 +2430,6 @@ function upgrade_063_to_064() {
 		}
 	}
 
-	if (!is_array($config['ppps']['ppp'])) {
-		$config['ppps']['ppp'] = array();
-	}
 	$a_ppps = &$config['ppps']['ppp'];
 
 	foreach ($ifcfg as $ifname => $ifinfo) {
@@ -2514,7 +2515,8 @@ function upgrade_064_to_065() {
 function upgrade_065_to_066() {
 	global $config;
 
-	$dhcrelaycfg =& $config['dhcrelay'];
+	init_config_arr(array('dhcrelay'));
+	$dhcrelaycfg = &$config['dhcrelay'];
 
 	if (is_array($dhcrelaycfg)) {
 		$dhcrelayifs = array();
@@ -3179,7 +3181,7 @@ function upgrade_090_to_091() {
 function upgrade_091_to_092() {
 	global $config;
 
-	if (is_array($config['nat']['advancedoutbound']) && is_array($config['nat']['advancedoutbound']['rule'])) {
+	if (is_array($config['nat']['advancedoutbound']['rule'])) {
 		$nat_rules = &$config['nat']['advancedoutbound']['rule'];
 		for ($i = 0; isset($nat_rules[$i]); $i++) {
 			if (empty($nat_rules[$i]['interface'])) {
@@ -3742,11 +3744,8 @@ function upgrade_117_to_118() {
 		unset($config['system']['cert']);
 	}
 
-	if (!isset($config['ipsec']['phase1'])) {
-		return;
-	}
-
-	$a_phase1 =& $config['ipsec']['phase1'];
+	init_config_arr(array('ipsec', 'phase1'));
+	$a_phase1 = &$config['ipsec']['phase1'];
 
 	foreach ($a_phase1 as &$ph1_entry) {
 		// update asn1dn strings from racoon's format to strongswan's
@@ -3769,7 +3768,8 @@ function upgrade_118_to_119() {
 	}
 
 	// change peerid_type to 'any' for EAP types to retain previous behavior of omitting rightid
-	$a_phase1 =& $config['ipsec']['phase1'];
+	init_config_arr(array('ipsec', 'phase1'));
+	$a_phase1 = &$config['ipsec']['phase1'];
 
 	foreach ($a_phase1 as &$ph1_entry) {
 		if (strstr($ph1_entry['authentication_method'], 'eap')) {
@@ -3803,7 +3803,7 @@ function upgrade_120_to_121() {
 		return;
 	}
 
-	$miniupnpd =& $config['installedpackages']['miniupnpd']['config'][0];
+	$miniupnpd = &$config['installedpackages']['miniupnpd']['config'][0];
 
 	$miniupnpd['row'] = array();
 
@@ -3834,7 +3834,7 @@ function upgrade_122_to_123() {
 
 	// Cleanup firewall rules
 	if (isset($config['filter']['rule']) && is_array($config['filter']['rule'])) {
-		$rules =& $config['filter']['rule'];
+		$rules = &$config['filter']['rule'];
 		$last_rule = count($rules) - 1;
 		// Process in reverse order to be able to unset items
 		for ($i = $last_rule; $i >= 0; $i--) {
@@ -3855,7 +3855,7 @@ function upgrade_122_to_123() {
 
 	// Cleanup 1:1 NAT rules
 	if (isset($config['nat']['onetoone']) && is_array($config['nat']['onetoone'])) {
-		$onetoone =& $config['nat']['onetoone'];
+		$onetoone = &$config['nat']['onetoone'];
 		$last_rule = count($onetoone) - 1;
 		// Process in reverse order to be able to unset items
 		for ($i = $last_rule; $i >= 0; $i--) {
@@ -3876,7 +3876,7 @@ function upgrade_122_to_123() {
 
 	// Cleanup npt NAT rules
 	if (isset($config['nat']['npt']) && is_array($config['nat']['npt'])) {
-		$npt =& $config['nat']['npt'];
+		$npt = &$config['nat']['npt'];
 		$last_rule = count($npt) - 1;
 		// Process in reverse order to be able to unset items
 		for ($i = $last_rule; $i >= 0; $i--) {
@@ -3889,7 +3889,7 @@ function upgrade_122_to_123() {
 
 	// Cleanup Port-forward NAT rules
 	if (isset($config['nat']['rule']) && is_array($config['nat']['rule'])) {
-		$nat_rules =& $config['nat']['rule'];
+		$nat_rules = &$config['nat']['rule'];
 		$last_rule = count($nat_rules) - 1;
 		// Process in reverse order to be able to unset items
 		for ($i = $last_rule; $i >= 0; $i--) {
@@ -3910,7 +3910,7 @@ function upgrade_122_to_123() {
 
 	// Cleanup Port-forward NAT rules
 	if (isset($config['nat']['outbound']['rule']) && is_array($config['nat']['outbound']['rule'])) {
-		$out_rules =& $config['nat']['outbound']['rule'];
+		$out_rules = &$config['nat']['outbound']['rule'];
 		$last_rule = count($out_rules) - 1;
 		// Process in reverse order to be able to unset items
 		for ($i = $last_rule; $i >= 0; $i--) {
@@ -4378,12 +4378,7 @@ function upgrade_141_to_142() {
 	global $config;
 	/* Convert Namecheap type DynDNS entries to the new split hostname and domain format */
 
-	if (!is_array($config['dyndnses'])) {
-		$config['dyndnses'] = array();
-	}
-	if (!is_array($config['dyndnses']['dyndns'])) {
-		$config['dyndnses']['dyndns'] = array();
-	}
+	init_config_arr(array('dyndnses', 'dyndns'));
 	$a_dyndns = &$config['dyndnses']['dyndns'];
 
 	foreach ($a_dyndns as &$dyndns) {
@@ -4950,12 +4945,7 @@ function upgrade_156_to_157() {
 	global $config;
 	/* Convert Cloudflare and GratisDNS type DynDNS entries to the new split hostname and domain format */
 
-	if (!is_array($config['dyndnses'])) {
-		$config['dyndnses'] = array();
-	}
-	if (!is_array($config['dyndnses']['dyndns'])) {
-		$config['dyndnses']['dyndns'] = array();
-	}
+	init_config_arr(array('dyndnses', 'dyndns'));
 	$a_dyndns = &$config['dyndnses']['dyndns'];
 
 	foreach ($a_dyndns as &$dyndns) {
@@ -4983,12 +4973,7 @@ function upgrade_157_to_158() {
 	global $config;
 	/* Convert Dynamic DNS passwords to base64 encoding. Redmine #6688 */
 
-	if (!is_array($config['dyndnses'])) {
-		$config['dyndnses'] = array();
-	}
-	if (!is_array($config['dyndnses']['dyndns'])) {
-		$config['dyndnses']['dyndns'] = array();
-	}
+	init_config_arr(array('dyndnses', 'dyndns'));
 	$a_dyndns = &$config['dyndnses']['dyndns'];
 
 	foreach ($a_dyndns as &$dyndns) {
@@ -5490,7 +5475,7 @@ function upgrade_173_to_174() {
 function upgrade_174_to_175() {
 	global $config;
 	init_config_arr(array('ipsec', 'phase1'));
-	if (is_array($config['ipsec']['phase1'])) {
+	if (count($config['ipsec']['phase1'])) {
 		$a_phase1 = &$config['ipsec']['phase1'];
 		foreach($a_phase1 as &$phase1) {
 			if (empty($phase1)) {
@@ -5759,10 +5744,7 @@ function upgrade_184_to_185() {
 	if (is_array($config['installedpackages']['autoconfigbackup']['config'][0])) {
 		$acbpkg = &$config['installedpackages']['autoconfigbackup']['config'][0];
 
-		if (!is_array($config['system']['acb'])) {
-			$config['system']['acb'] = array();
-		}
-
+		init_config_arr(array('system', 'acb'));
 		$acb = &$config['system']['acb'];
 		$acb['enable'] = ($acbpkg['enable_acb'] != 'disabled') ?  'yes':'no';
 		$acb['gold_encryption_password'] = $acbpkg['crypto_password'];
diff --git a/src/etc/inc/util.inc b/src/etc/inc/util.inc
index cd33d5918c..4367118283 100644
--- a/src/etc/inc/util.inc
+++ b/src/etc/inc/util.inc
@@ -1268,7 +1268,9 @@ function get_configured_vip_list($family = 'all', $type = VIP_ALL) {
 	global $config;
 
 	$list = array();
-	if (!is_array($config['virtualip']['vip']) || empty($config['virtualip']['vip'])) {
+	if (!is_array($config['virtualip']) ||
+	    !is_array($config['virtualip']['vip']) ||
+	    empty($config['virtualip']['vip'])) {
 		return ($list);
 	}
 
@@ -1328,7 +1330,9 @@ function get_configured_vip_subnetv6($vipinterface = '') {
 function get_configured_vip_detail($vipinterface = '', $family = 'inet', $what = 'ip') {
 	global $config;
 
-	if (empty($vipinterface) || !is_array($config['virtualip']['vip']) ||
+	if (empty($vipinterface) ||
+	    !is_array($config['virtualip']) ||
+	    !is_array($config['virtualip']['vip']) ||
 	    empty($config['virtualip']['vip'])) {
 		return (NULL);
 	}
diff --git a/src/etc/phpshellsessions/disablecarp b/src/etc/phpshellsessions/disablecarp
index 03999932e5..f390af6c10 100644
--- a/src/etc/phpshellsessions/disablecarp
+++ b/src/etc/phpshellsessions/disablecarp
@@ -25,6 +25,7 @@ require_once("util.inc");
 
 set_single_sysctl("net.inet.carp.allow", "0");
 if (is_array($config['virtualip']['vip'])) {
+	init_config_arr(array('virtualip', 'vip'));
 	$viparr = &$config['virtualip']['vip'];
 	foreach ($viparr as $vip) {
 		switch ($vip['mode']) {
diff --git a/src/etc/phpshellsessions/enablecarp b/src/etc/phpshellsessions/enablecarp
index 24011fcce7..0897296faa 100644
--- a/src/etc/phpshellsessions/enablecarp
+++ b/src/etc/phpshellsessions/enablecarp
@@ -24,6 +24,7 @@ require_once("interfaces.inc");
 require_once("util.inc");
 
 if (is_array($config['virtualip']['vip'])) {
+	init_config_arr(array('virtualip', 'vip'));
 	$viparr = &$config['virtualip']['vip'];
 	foreach ($viparr as $vip) {
 		switch ($vip['mode']) {
diff --git a/src/etc/rc.initial.setlanip b/src/etc/rc.initial.setlanip
index 6a1ae28d47..f43ec53758 100755
--- a/src/etc/rc.initial.setlanip
+++ b/src/etc/rc.initial.setlanip
@@ -201,9 +201,7 @@ function next_unused_gateway_name($interface) {
 
 function add_gateway_to_config($interface, $gatewayip, $inet_type) {
 	global $g, $config, $dry_run;
-	if (!is_array($config['gateways']['gateway_item'])) {
-		$config['gateways']['gateway_item'] = array();
-	}
+	init_config_arr(array('gateways', 'gateway_item'));
 	$a_gateways = &$config['gateways']['gateway_item'];
 	if ($dry_run) {
 		print_r($a_gateways);
diff --git a/src/usr/local/www/diag_dns.php b/src/usr/local/www/diag_dns.php
index ccfd81cc5b..cefcf9a154 100644
--- a/src/usr/local/www/diag_dns.php
+++ b/src/usr/local/www/diag_dns.php
@@ -31,16 +31,7 @@ require_once("guiconfig.inc");
 
 $host = trim($_REQUEST['host'], " \t\n\r\0\x0B[];\"'");
 
-/* If this section of config.xml has not been populated yet we need to set it up
-*/
-if (!is_array($config['aliases'])) {
-	$config['aliases'] = array();
-}
-
-if (!is_array($config['aliases']['alias'])) {
-	$config['aliases']['alias'] = array();
-}
-
+init_config_arr(array('aliases', 'alias'));
 $a_aliases = &$config['aliases']['alias'];
 
 $aliasname = substr(str_replace(array(".", "-"), "_", $host), 0, 31);
diff --git a/src/usr/local/www/firewall_aliases.php b/src/usr/local/www/firewall_aliases.php
index 335059d6e9..be2bcfd8f4 100644
--- a/src/usr/local/www/firewall_aliases.php
+++ b/src/usr/local/www/firewall_aliases.php
@@ -35,14 +35,7 @@ require_once("functions.inc");
 require_once("filter.inc");
 require_once("shaper.inc");
 
-if (!is_array($config['aliases'])) {
-	$config['aliases'] = array();
-}
-
-if (!is_array($config['aliases']['alias'])) {
-	$config['aliases']['alias'] = array();
-}
-
+init_config_arr(array('aliases', 'alias'));
 $a_aliases = &$config['aliases']['alias'];
 
 $tab = ($_REQUEST['tab'] == "" ? "ip" : preg_replace("/\W/", "", $_REQUEST['tab']));
diff --git a/src/usr/local/www/firewall_aliases_edit.php b/src/usr/local/www/firewall_aliases_edit.php
index 39dee98feb..2b190f1485 100644
--- a/src/usr/local/www/firewall_aliases_edit.php
+++ b/src/usr/local/www/firewall_aliases_edit.php
@@ -55,14 +55,7 @@ $reserved_ifs = get_configured_interface_list(true);
 $pf_reserved_keywords = array_merge($pf_reserved_keywords, $reserved_ifs, $reserved_table_names);
 $max_alias_addresses = 5000;
 
-if (!is_array($config['aliases'])) {
-	$config['aliases'] = array();
-}
-
-if (!is_array($config['aliases']['alias'])) {
-	$config['aliases']['alias'] = array();
-}
-
+init_config_arr(array('aliases', 'alias'));
 $a_aliases = &$config['aliases']['alias'];
 
 // Debugging
diff --git a/src/usr/local/www/firewall_aliases_import.php b/src/usr/local/www/firewall_aliases_import.php
index f90533a761..dae3cfc4b5 100644
--- a/src/usr/local/www/firewall_aliases_import.php
+++ b/src/usr/local/www/firewall_aliases_import.php
@@ -55,13 +55,7 @@ if (empty($tab)) {
 $pgtitle = array(gettext("Firewall"), gettext("Aliases"), gettext("Bulk import"));
 $pglinks = array("", "firewall_aliases.php?tab=" . $tab, "@self");
 
-if (!is_array($config['aliases'])) {
-	$config['aliases'] = array();
-}
-
-if (!is_array($config['aliases']['alias'])) {
-	$config['aliases']['alias'] = array();
-}
+init_config_arr(array('aliases', 'alias'));
 $a_aliases = &$config['aliases']['alias'];
 
 if ($_POST) {
diff --git a/src/usr/local/www/firewall_nat.php b/src/usr/local/www/firewall_nat.php
index 335aff0502..40f56b56c9 100644
--- a/src/usr/local/www/firewall_nat.php
+++ b/src/usr/local/www/firewall_nat.php
@@ -39,6 +39,7 @@ require_once("itemid.inc");
 init_config_arr(array('nat', 'separator'));
 init_config_arr(array('nat', 'rule'));
 $a_nat = &$config['nat']['rule'];
+$a_separators = &$config['nat']['separator'];
 
 /* update rule order, POST[rule] is an array of ordered IDs */
 if (array_key_exists('order-store', $_REQUEST) && have_natpfruleint_access($natent['interface'])) {
@@ -107,7 +108,6 @@ if (($_POST['act'] == "del") && have_natpfruleint_access($natent['interface']))
 		unset($a_nat[$_POST['id']]);
 
 		// Update the separators
-		$a_separators = &$config['nat']['separator'];
 		$ridx = $_POST['id'];
 		$mvnrows = -1;
 		move_separators($a_separators, $ridx, $mvnrows);
@@ -128,7 +128,6 @@ if (isset($_POST['del_x']) && have_natpfruleint_access($natent['interface'])) {
 
 	/* delete selected rules */
 	if (is_array($_POST['rule']) && count($_POST['rule'])) {
-		$a_separators = &$config['nat']['separator'];
 		$num_deleted = 0;
 
 		foreach ($_POST['rule'] as $rulei) {
diff --git a/src/usr/local/www/firewall_nat_edit.php b/src/usr/local/www/firewall_nat_edit.php
index 0caeb317ba..cd7139df07 100644
--- a/src/usr/local/www/firewall_nat_edit.php
+++ b/src/usr/local/www/firewall_nat_edit.php
@@ -46,9 +46,11 @@ foreach ($ifdisp as $kif => $kdescr) {
 	$specialsrcdst[] = "{$kif}ip";
 }
 
+init_config_arr(array('filter', 'rule'));
 init_config_arr(array('nat', 'separator'));
 init_config_arr(array('nat', 'rule'));
 $a_nat = &$config['nat']['rule'];
+$a_separators = &$config['nat']['separator'];
 
 if (isset($_REQUEST['id']) && is_numericint($_REQUEST['id'])) {
 	$id = $_REQUEST['id'];
@@ -512,7 +514,6 @@ if ($_POST['save']) {
 				array_splice($a_nat, $after+1, 0, array($natent));
 
 				// Update the separators
-				$a_separators = &$config['nat']['separator'];
 				$ridx = $after;
 				$mvnrows = +1;
 				move_separators($a_separators, $ridx, $mvnrows);
diff --git a/src/usr/local/www/firewall_rules.php b/src/usr/local/www/firewall_rules.php
index 2c6c302cc4..a6fea90b05 100644
--- a/src/usr/local/www/firewall_rules.php
+++ b/src/usr/local/www/firewall_rules.php
@@ -108,14 +108,7 @@ function delete_nat_association($id) {
 	}
 }
 
-if (!is_array($config['filter'])) {
-	$config['filter'] = array();
-}
-
-if (!is_array($config['filter']['rule'])) {
-	$config['filter']['rule'] = array();
-}
-
+init_config_arr(array('filter', 'rule'));
 filter_rules_sort();
 $a_filter = &$config['filter']['rule'];
 
@@ -150,6 +143,7 @@ if ($_POST['act'] == "del") {
 		unset($a_filter[$_POST['id']]);
 
 		// Update the separators
+		init_config_arr(array('filter', 'separator', strtolower($if)));
 		$a_separators = &$config['filter']['separator'][strtolower($if)];
 		$ridx = ifridx($if, $_POST['id']);	// get rule index within interface
 		$mvnrows = -1;
@@ -174,6 +168,7 @@ if (isset($_POST['del_x'])) {
 	$deleted = false;
 
 	if (is_array($_POST['rule']) && count($_POST['rule'])) {
+		init_config_arr(array('filter', 'separator', strtolower($if)));
 		$a_separators = &$config['filter']['separator'][strtolower($if)];
 		$num_deleted = 0;
 
@@ -505,14 +500,8 @@ foreach ($a_filter as $filteri => $filterent):
 			pprint_port($filterent['destination']['port'])
 		);
 
-		if (!is_array($config['schedules'])) {
-			$config['schedules'] = array();
-		}
-
-		if (!is_array($config['schedules']['schedule'])) {
-			$config['schedules']['schedule'] = array();
-		}
 		//build Schedule popup box
+		init_config_arr(array('schedules', 'schedule'));
 		$a_schedules = &$config['schedules']['schedule'];
 		$schedule_span_begin = "";
 		$schedule_span_end = "";
